#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct SummarizeCartesian3dNode {
    #[builder(custom(type = super::Cartesian3dNode, convert = Box::new))]
    #[serde(rename = "input")]
    input: Box<super::Cartesian3dNode>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::Cartesian3dBounds>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "bounds", skip_serializing_if = "Option::is_none", default)]
    bounds: Option<Box<super::Cartesian3dBounds>>,
    #[builder(default, into)]
    #[serde(rename = "maxPoints", skip_serializing_if = "Option::is_none", default)]
    max_points: Option<i32>,
    #[builder(
        custom(
            type = super::super::super::api::ScatterSummarizationStrategy,
            convert = Box::new
        )
    )]
    #[serde(rename = "summarizationStrategy")]
    summarization_strategy: Box<super::super::super::api::ScatterSummarizationStrategy>,
}
impl SummarizeCartesian3dNode {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        input: super::Cartesian3dNode,
        summarization_strategy: super::super::super::api::ScatterSummarizationStrategy,
    ) -> Self {
        Self::builder()
            .input(input)
            .summarization_strategy(summarization_strategy)
            .build()
    }
    #[inline]
    pub fn input(&self) -> &super::Cartesian3dNode {
        &*self.input
    }
    #[inline]
    pub fn bounds(&self) -> Option<&super::Cartesian3dBounds> {
        self.bounds.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn max_points(&self) -> Option<i32> {
        self.max_points.as_ref().map(|o| *o)
    }
    #[inline]
    pub fn summarization_strategy(
        &self,
    ) -> &super::super::super::api::ScatterSummarizationStrategy {
        &*self.summarization_strategy
    }
}
